
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.y"

/***************************************************************************
 *   Copyright (C) 2006-2010 by Matteo Franchin                            *
 *   fnch@libero.it                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "types.h"
#include "defaults.h"
#include "mem.h"
#include "messages.h"
#include "tokenizer.h"
#include "srcpos.h"
#include "ast.h"
#include "parserh.h"

static ASTNode *program_node = NULL;

int yyparse(void);
int yylex(void);
void yyerror(char *s);
static void My_Syntax_Error();

#define SRC(ast_node, node_src) \
  do \
    if (ast_node != NULL) { \
      ast_node->src.begin.line = node_src.first_line; \
      ast_node->src.begin.col = node_src.first_column; \
      ast_node->src.end.line = node_src.last_line; \
      ast_node->src.end.col = node_src.last_column; \
      ast_node->src.begin.file_name = ast_node->src.end.file_name = "unknown"; \
    } \
  while (0)



/* Line 189 of yacc.c  */
#line 128 "parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_NEWLINE = 258,
     TOK_ERRSEP = 259,
     TOK_TO = 260,
     TOK_MAPTO = 261,
     TOK_SELF = 262,
     TOK_COMBINE = 263,
     TOK_TTAG = 264,
     TOK_INC = 265,
     TOK_DEC = 266,
     TOK_SHL = 267,
     TOK_SHR = 268,
     TOK_EQ = 269,
     TOK_NE = 270,
     TOK_LT = 271,
     TOK_LE = 272,
     TOK_GT = 273,
     TOK_GE = 274,
     TOK_LOR = 275,
     TOK_LAND = 276,
     TOK_APLUS = 277,
     TOK_AMINUS = 278,
     TOK_ATIMES = 279,
     TOK_ADIV = 280,
     TOK_AREM = 281,
     TOK_ABAND = 282,
     TOK_ABXOR = 283,
     TOK_ABOR = 284,
     TOK_ASHL = 285,
     TOK_ASHR = 286,
     TOK_POW = 287,
     TOK_ERR = 288,
     TOK_IDENTIFIER = 289,
     TOK_TYPE_IDENT = 290,
     TOK_CONSTANT = 291,
     TOK_STRING = 292
   };
#endif
/* Tokens.  */
#define TOK_NEWLINE 258
#define TOK_ERRSEP 259
#define TOK_TO 260
#define TOK_MAPTO 261
#define TOK_SELF 262
#define TOK_COMBINE 263
#define TOK_TTAG 264
#define TOK_INC 265
#define TOK_DEC 266
#define TOK_SHL 267
#define TOK_SHR 268
#define TOK_EQ 269
#define TOK_NE 270
#define TOK_LT 271
#define TOK_LE 272
#define TOK_GT 273
#define TOK_GE 274
#define TOK_LOR 275
#define TOK_LAND 276
#define TOK_APLUS 277
#define TOK_AMINUS 278
#define TOK_ATIMES 279
#define TOK_ADIV 280
#define TOK_AREM 281
#define TOK_ABAND 282
#define TOK_ABXOR 283
#define TOK_ABOR 284
#define TOK_ASHL 285
#define TOK_ASHR 286
#define TOK_POW 287
#define TOK_ERR 288
#define TOK_IDENTIFIER 289
#define TOK_TYPE_IDENT 290
#define TOK_CONSTANT 291
#define TOK_STRING 292




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 56 "parser.y"

  char *        String;
  BoxType       TTag;
  BoxComb       Combine;
  ASTScope      Scope;
  ASTUnOp       UnaryOperator;
  ASTBinOp      BinaryOperator;
  ASTNodePtr    Node;
  ASTTypeMemb   TypeMemb;
  ASTSep        Sep;
  ASTSelfLevel  SelfLevel;



/* Line 214 of yacc.c  */
#line 253 "parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 278 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  125
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   344

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  61
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  55
/* YYNRULES -- Number of rules.  */
#define YYNRULES  138
/* YYNRULES -- Number of states.  */
#define YYNSTATES  193

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   292

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    43,     2,     2,     2,    47,    56,     2,
      51,    52,    45,    41,    38,    42,    55,    46,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    40,    39,
      48,    50,    49,    59,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    53,    60,    54,    57,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    58,     2,    44,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    12,    14,    16,    18,
      21,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    42,    44,    46,    48,    50,    52,    54,    56,    58,
      60,    62,    64,    66,    68,    70,    72,    74,    76,    78,
      80,    82,    84,    86,    88,    91,    94,    97,   100,   102,
     104,   106,   109,   111,   113,   116,   118,   122,   126,   128,
     133,   135,   140,   145,   149,   153,   156,   157,   159,   161,
     164,   166,   170,   172,   176,   178,   182,   184,   188,   190,
     194,   196,   200,   202,   206,   208,   212,   214,   218,   220,
     224,   226,   230,   232,   236,   238,   240,   243,   245,   247,
     250,   253,   256,   259,   262,   264,   266,   270,   274,   277,
     281,   284,   288,   292,   296,   298,   303,   305,   309,   311,
     313,   316,   320,   324,   326,   328,   332,   333,   335,   339,
     345,   346,   348,   350,   353,   357,   360,   362,   366
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
     115,     0,    -1,    38,    -1,     3,    -1,    62,    -1,    63,
      62,    -1,    62,    -1,    39,    -1,    40,    -1,    65,    40,
      -1,    -1,    65,    -1,    41,    -1,    42,    -1,    43,    -1,
      10,    -1,    11,    -1,    44,    -1,    10,    -1,    11,    -1,
      41,    -1,    42,    -1,    45,    -1,    46,    -1,    47,    -1,
      12,    -1,    13,    -1,    14,    -1,    15,    -1,    48,    -1,
      17,    -1,    49,    -1,    19,    -1,    50,    -1,    22,    -1,
      23,    -1,    24,    -1,    26,    -1,    25,    -1,    30,    -1,
      31,    -1,    27,    -1,    28,    -1,    29,    -1,    95,    63,
      -1,    76,    63,    -1,    63,    95,    -1,    75,    95,    -1,
      75,    -1,    76,    -1,    37,    -1,    78,    37,    -1,    36,
      -1,    78,    -1,    34,    66,    -1,     7,    -1,    51,    95,
      52,    -1,    51,    77,    52,    -1,    79,    -1,    80,    51,
      95,    52,    -1,   112,    -1,    80,    53,   114,    54,    -1,
     106,    53,   114,    54,    -1,    81,    55,    34,    -1,    81,
      55,    35,    -1,    80,    68,    -1,    -1,    80,    -1,    80,
      -1,    67,    82,    -1,    82,    -1,    83,    32,    82,    -1,
      83,    -1,    84,    70,    83,    -1,    84,    -1,    85,    69,
      84,    -1,    85,    -1,    86,    71,    85,    -1,    86,    -1,
      87,    73,    86,    -1,    87,    -1,    88,    72,    87,    -1,
      88,    -1,    89,    56,    88,    -1,    89,    -1,    90,    57,
      89,    -1,    90,    -1,    91,    58,    90,    -1,    91,    -1,
      92,    21,    91,    -1,    92,    -1,    93,    20,    92,    -1,
      93,    -1,    93,    74,    94,    -1,    94,    -1,   106,    -1,
     106,    34,    -1,   106,    -1,    34,    -1,   106,    34,    -1,
      96,    63,    -1,    99,    63,    -1,    63,    96,    -1,    98,
      97,    -1,    98,    -1,    99,    -1,   106,     5,   106,    -1,
     101,     5,   106,    -1,    35,    66,    -1,   102,    55,    35,
      -1,    35,    66,    -1,    51,   106,    52,    -1,    51,   100,
      52,    -1,    51,   101,    52,    -1,   103,    -1,   104,    51,
      95,    52,    -1,   104,    -1,   104,     6,   105,    -1,   105,
      -1,   106,    -1,    10,   106,    -1,   102,    50,   107,    -1,
     102,    50,   108,    -1,   106,    -1,     9,    -1,   109,     8,
     102,    -1,    -1,    78,    -1,   110,   111,    59,    -1,   110,
     111,    53,   114,    54,    -1,    -1,   108,    -1,    95,    -1,
      60,    95,    -1,    53,   114,    54,    -1,     1,    64,    -1,
     113,    -1,   114,    64,   113,    -1,   114,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   115,   115,   116,   120,   121,   125,   126,   132,   133,
     137,   138,   143,   144,   145,   146,   147,   148,   152,   153,
     157,   158,   162,   163,   164,   168,   169,   173,   174,   178,
     179,   180,   181,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   200,   201,   205,   206,   211,   212,
     217,   218,   223,   224,   225,   227,   228,   229,   233,   234,
     235,   236,   238,   239,   242,   245,   249,   250,   254,   255,
     259,   260,   265,   266,   270,   271,   275,   276,   280,   281,
     285,   286,   290,   291,   295,   296,   300,   301,   305,   306,
     310,   311,   315,   316,   321,   328,   329,   333,   334,   335,
     339,   341,   345,   347,   352,   353,   358,   359,   365,   367,
     373,   375,   376,   377,   381,   382,   386,   387,   392,   396,
     397,   401,   402,   410,   411,   415,   421,   422,   426,   427,
     434,   435,   436,   437,   439,   440,   448,   449,   454
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_NEWLINE", "TOK_ERRSEP", "TOK_TO",
  "TOK_MAPTO", "TOK_SELF", "TOK_COMBINE", "TOK_TTAG", "TOK_INC", "TOK_DEC",
  "TOK_SHL", "TOK_SHR", "TOK_EQ", "TOK_NE", "TOK_LT", "TOK_LE", "TOK_GT",
  "TOK_GE", "TOK_LOR", "TOK_LAND", "TOK_APLUS", "TOK_AMINUS", "TOK_ATIMES",
  "TOK_ADIV", "TOK_AREM", "TOK_ABAND", "TOK_ABXOR", "TOK_ABOR", "TOK_ASHL",
  "TOK_ASHR", "TOK_POW", "TOK_ERR", "TOK_IDENTIFIER", "TOK_TYPE_IDENT",
  "TOK_CONSTANT", "TOK_STRING", "','", "';'", "':'", "'+'", "'-'", "'!'",
  "'~'", "'*'", "'/'", "'%'", "'<'", "'>'", "'='", "'('", "')'", "'['",
  "']'", "'.'", "'&'", "'^'", "'|'", "'?'", "'\\\\'", "$accept",
  "void_sep", "void_seps", "sep", "colons", "opt_scope", "un_op",
  "post_op", "add_op", "mul_op", "shift_op", "eq_op", "cmp_op",
  "assign_op", "expr_sep", "sep_expr", "struc_expr", "string_concat",
  "prim_expr", "postfix_expr", "opt_postfix_expr", "unary_expr",
  "pow_expr", "mul_expr", "add_expr", "shift_expr", "cmp_expr", "eq_expr",
  "band_expr", "bxor_expr", "bor_expr", "land_expr", "lor_expr",
  "assign_expr", "expr", "struc_type_1st", "struc_type_2nd", "type_sep",
  "sep_type", "struc_type", "species_type", "named_type", "prim_type",
  "array_type", "func_type", "type", "inc_type", "assign_type", "at_left",
  "procedure", "opt_c_name", "procedure_decl", "statement",
  "statement_list", "program", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    44,    59,
      58,    43,    45,    33,   126,    42,    47,    37,    60,    62,
      61,    40,    41,    91,    93,    46,    38,    94,   124,    63,
      92
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    61,    62,    62,    63,    63,    64,    64,    65,    65,
      66,    66,    67,    67,    67,    67,    67,    67,    68,    68,
      69,    69,    70,    70,    70,    71,    71,    72,    72,    73,
      73,    73,    73,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    75,    75,    76,    76,    77,    77,
      78,    78,    79,    79,    79,    79,    79,    79,    80,    80,
      80,    80,    80,    80,    80,    80,    81,    81,    82,    82,
      83,    83,    84,    84,    85,    85,    86,    86,    87,    87,
      88,    88,    89,    89,    90,    90,    91,    91,    92,    92,
      93,    93,    94,    94,    95,    96,    96,    97,    97,    97,
      98,    98,    99,    99,   100,   100,   101,   101,   102,   102,
     103,   103,   103,   103,   104,   104,   105,   105,   106,   107,
     107,   108,   108,   109,   109,   110,   111,   111,   112,   112,
     113,   113,   113,   113,   113,   113,   114,   114,   115
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     2,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     1,
       1,     2,     1,     1,     2,     1,     3,     3,     1,     4,
       1,     4,     4,     3,     3,     2,     0,     1,     1,     2,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     1,     2,     1,     1,     2,
       2,     2,     2,     2,     1,     1,     3,     3,     2,     3,
       2,     3,     3,     3,     1,     4,     1,     3,     1,     1,
       2,     3,     3,     1,     1,     3,     0,     1,     3,     5,
       0,     1,     1,     2,     3,     2,     1,     3,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    55,   124,    15,    16,    10,    10,    52,    50,
      12,    13,    14,    17,    66,     0,    66,    66,    53,    58,
      68,     0,    70,    72,    74,    76,    78,    80,    82,    84,
      86,    88,    90,    92,    94,   132,     0,   114,   116,   118,
     123,   131,     0,   126,    60,   136,   138,     0,     3,     2,
       7,     6,   135,     8,    11,    54,   110,    10,     4,    66,
      48,    49,     0,     0,     0,   104,   105,     0,     0,    95,
       0,   133,    69,    51,    18,    19,    66,     0,    65,     0,
      66,    22,    23,    24,    66,    20,    21,    66,    25,    26,
      66,    30,    32,    29,    31,    66,    27,    28,    66,    66,
      66,    66,    66,    66,    34,    35,    36,    38,    37,    41,
      42,    43,    39,    40,    33,    66,     0,     0,     0,    66,
       0,     0,   127,     0,     0,     1,     9,   110,     5,    46,
     102,    95,    47,    45,    57,    56,    44,   100,    98,     0,
     103,    97,   101,   112,     0,   113,     0,    96,   111,   134,
       0,     0,    63,    64,    71,    73,    75,    77,    79,    81,
      83,    85,    87,    89,    91,    93,     0,   119,   121,   122,
     109,   117,     0,     0,    10,   125,     0,   128,   137,     0,
      95,    99,   107,   106,    59,    61,   120,   115,    62,   108,
       0,    95,   129
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    51,    59,   124,    54,    55,    17,    78,    87,    84,
      90,    98,    95,   115,    60,    61,    62,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    64,   140,    65,    66,    67,
      68,    36,    37,    38,    39,    40,   168,    41,    42,    43,
     123,    44,    45,    46,    47
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -59
static const yytype_int16 yypact[] =
{
     143,   110,   -59,   -59,   -59,   -59,   -21,   -21,   -59,   -59,
     -59,   -59,   -59,   -59,   244,   190,   293,   293,    -6,   -59,
      69,   -32,   -59,    -5,   -17,    -3,    79,   117,    91,   -20,
       2,   -11,    19,   185,   -59,   -59,   -30,   -59,    16,   -59,
      33,   -59,    95,    73,   -59,   -59,   110,   125,   -59,   -59,
     -59,   -59,   -59,   -59,   101,   -59,   -29,   -21,   -59,   244,
     255,     4,    87,    10,     4,   -19,     4,    93,     0,    85,
      43,   -59,   -59,   -59,   -59,   -59,   293,   190,   -59,    74,
     293,   -59,   -59,   -59,   293,   -59,   -59,   293,   -59,   -59,
     293,   -59,   -59,   -59,   -59,   293,   -59,   -59,   293,   293,
     293,   293,   293,   293,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,   -59,   293,   120,   121,   -18,   293,
     190,   122,    -6,   -35,    34,   -59,   -59,   -59,   -59,   -59,
     -59,    94,   -59,     4,   -59,   -59,     4,     4,   -59,    80,
     -59,   124,     4,   -59,   -18,   -59,   -18,   -59,   -59,   -59,
     107,    57,   -59,   -59,   -59,    -5,   -17,    -3,    79,   117,
      91,   -20,     2,   -11,    19,   -59,   -18,   -59,   -59,   -59,
     -59,   -59,   108,    60,   -21,   106,   190,   -59,   -59,    80,
      99,   -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
      62,   130,   -59
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -59,   -10,   -55,   167,   -59,    -7,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,   -59,   -59,   -59,   127,   -59,   -59,
     -59,   -14,    88,    86,    84,    81,    90,    96,    83,    89,
     100,   103,   -59,    77,    -2,   -58,   -59,   -59,   -59,   -59,
     -59,    68,   -59,   -59,   102,    -4,   -59,   105,   -59,   -59,
     -59,   -59,    98,   -13,   -59
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -131
static const yytype_int16 yytable[] =
{
      56,   130,    70,    72,    58,   144,   133,    48,   136,   137,
      69,   142,    63,    48,    71,   138,    57,    57,   176,    53,
     116,  -108,   118,    79,   177,   117,  -108,    80,    81,    82,
      83,    73,   139,   139,  -130,     1,    99,  -130,    85,    86,
     102,     2,    49,     3,     4,     5,    48,   101,    49,   128,
     127,    58,   145,    58,    58,   131,    58,   129,   132,   100,
      48,   141,   135,    48,   151,    48,   154,   119,     6,     7,
       8,     9,  -130,  -130,   150,    10,    11,    12,    13,    74,
      75,    49,    50,    48,   179,    14,   120,    15,  -130,   -66,
     146,    88,    89,  -123,    16,    49,    50,   149,    49,    50,
      49,    50,  -123,   121,   146,    96,    97,   173,   152,   153,
       9,   185,   167,    48,   188,    57,   192,   172,    49,   147,
      76,   130,    77,   128,   -67,   125,   128,   128,   147,    58,
     166,   139,   128,   147,    91,   180,    92,   148,   120,   134,
     182,   126,   183,  -130,     1,   143,  -130,   120,    49,    50,
       2,   148,     3,     4,     5,     7,   170,   174,   181,   184,
     187,   117,   186,   190,   147,    93,    94,   189,    52,   128,
     122,   139,   155,   156,   157,   191,   158,     6,     7,     8,
       9,  -130,  -130,   161,    10,    11,    12,    13,   159,   175,
     162,     1,   165,  -130,    14,   160,    15,     2,   -66,     3,
       4,     5,   163,    16,     0,   103,   164,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,     0,     0,     0,
     171,   169,   178,     0,     6,     7,     8,     9,  -130,  -130,
       0,    10,    11,    12,    13,   114,     0,     0,     0,     0,
       0,    14,     0,    15,  -130,   -66,     0,    48,     0,     0,
      16,     2,     0,     3,     4,     5,     0,     0,     0,     0,
       0,     0,     2,     0,     3,     4,     5,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,    57,
       8,     9,    49,     0,     0,    10,    11,    12,    13,     6,
      57,     8,     9,     0,     0,    14,    10,    11,    12,    13,
       2,     0,     3,     4,     5,     0,    14,     0,     0,     0,
     -66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,    57,     8,
       9,     0,     0,     0,    10,    11,    12,    13,     0,     0,
       0,     0,     0,     0,    14
};

static const yytype_int16 yycheck[] =
{
       7,    59,    15,    17,    14,     5,    61,     3,    63,    64,
      14,    66,    14,     3,    16,    34,    35,    35,    53,    40,
      50,    50,     6,    55,    59,    55,    55,    32,    45,    46,
      47,    37,    51,    51,     0,     1,    56,     3,    41,    42,
      21,     7,    38,     9,    10,    11,     3,    58,    38,    59,
      57,    61,    52,    63,    64,    59,    66,    59,    60,    57,
       3,    65,    52,     3,    77,     3,    80,    51,    34,    35,
      36,    37,    38,    39,    76,    41,    42,    43,    44,    10,
      11,    38,    39,     3,   139,    51,    53,    53,    54,    55,
       5,    12,    13,     8,    60,    38,    39,    54,    38,    39,
      38,    39,     8,     8,     5,    14,    15,   120,    34,    35,
      37,    54,   116,     3,    54,    35,    54,   119,    38,    34,
      51,   179,    53,   133,    55,     0,   136,   137,    34,   139,
      10,    51,   142,    34,    17,   139,    19,    52,    53,    52,
     144,    40,   146,     0,     1,    52,     3,    53,    38,    39,
       7,    52,     9,    10,    11,    35,    35,    35,    34,    52,
      52,    55,   166,   176,    34,    48,    49,   174,     1,   179,
      43,    51,    84,    87,    90,   179,    95,    34,    35,    36,
      37,    38,    39,   100,    41,    42,    43,    44,    98,   121,
     101,     1,   115,     3,    51,    99,    53,     7,    55,     9,
      10,    11,   102,    60,    -1,    20,   103,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
     118,   116,   124,    -1,    34,    35,    36,    37,    38,    39,
      -1,    41,    42,    43,    44,    50,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    53,    54,    55,    -1,     3,    -1,    -1,
      60,     7,    -1,     9,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,     7,    -1,     9,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,
      36,    37,    38,    -1,    -1,    41,    42,    43,    44,    34,
      35,    36,    37,    -1,    -1,    51,    41,    42,    43,    44,
       7,    -1,     9,    10,    11,    -1,    51,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    35,    36,
      37,    -1,    -1,    -1,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     7,     9,    10,    11,    34,    35,    36,    37,
      41,    42,    43,    44,    51,    53,    60,    67,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,   102,   103,   104,   105,
     106,   108,   109,   110,   112,   113,   114,   115,     3,    38,
      39,    62,    64,    40,    65,    66,    66,    35,    62,    63,
      75,    76,    77,    95,    96,    98,    99,   100,   101,   106,
     114,    95,    82,    37,    10,    11,    51,    53,    68,    55,
      32,    45,    46,    47,    70,    41,    42,    69,    12,    13,
      71,    17,    19,    48,    49,    73,    14,    15,    72,    56,
      57,    58,    21,    20,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    50,    74,    50,    55,     6,    51,
      53,     8,    78,   111,    64,     0,    40,    66,    62,    95,
      96,   106,    95,    63,    52,    52,    63,    63,    34,    51,
      97,   106,    63,    52,     5,    52,     5,    34,    52,    54,
      95,   114,    34,    35,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    94,    10,   106,   107,   108,
      35,   105,    95,   114,    35,   102,    53,    59,   113,    63,
     106,    34,   106,   106,    52,    54,   106,    52,    54,    66,
     114,   106,    54
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1455 of yacc.c  */
#line 125 "parser.y"
    {(yyval.Sep) = ASTSEP_VOID;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 126 "parser.y"
    {(yyval.Sep) = ASTSEP_PAUSE;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 132 "parser.y"
    {(yyval.Scope) = 1;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 133 "parser.y"
    {(yyval.Scope) = (yyvsp[(1) - (2)].Scope) + 1;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 137 "parser.y"
    {(yyval.Scope) = 0;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 138 "parser.y"
    {(yyval.Scope) = (yyvsp[(1) - (1)].Scope);}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 143 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_PLUS;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 144 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_NEG;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 145 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_NOT;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 146 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_LINC;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 147 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_LDEC;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 148 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_BNOT;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 152 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_RINC;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 153 "parser.y"
    {(yyval.UnaryOperator) = ASTUNOP_RDEC;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 157 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ADD;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 158 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_SUB;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 162 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_MUL;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 163 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_DIV;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 164 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_REM;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 168 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_SHL;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 169 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_SHR;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 173 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_EQ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 174 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_NE;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 178 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_LT;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 179 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_LE;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 180 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_GT;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 181 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_GE;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 185 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ASSIGN;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 186 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_APLUS;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 187 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_AMINUS;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 188 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ATIMES;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 189 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_AREM;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 190 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ADIV;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 191 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ASHL;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 192 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ASHR;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 193 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ABAND;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 194 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ABXOR;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 195 "parser.y"
    {(yyval.BinaryOperator) = ASTBINOP_ABOR;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 200 "parser.y"
    {(yyval.Node) = ASTNodeStruc_New(NULL, (yyvsp[(1) - (2)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 201 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (2)].Node);}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 205 "parser.y"
    {(yyval.Node) = ASTNodeStruc_New(NULL, (yyvsp[(2) - (2)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 206 "parser.y"
    {(yyval.Node) = ASTNodeStruc_Add_Member((yyvsp[(1) - (2)].Node), NULL, (yyvsp[(2) - (2)].Node));
                               SRC((yyval.Node), (yyloc));}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 211 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 212 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 217 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 218 "parser.y"
    {(yyval.Node) = ASTNodeString_Concat((yyvsp[(1) - (2)].Node), (yyvsp[(2) - (2)].Node));
                                  SRC((yyval.Node), (yyloc));}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 223 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 224 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 225 "parser.y"
    {(yyval.Node) = ASTNodeVar_New((yyvsp[(1) - (2)].String), 0);
                                  BoxMem_Free((yyvsp[(1) - (2)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 227 "parser.y"
    {(yyval.Node) = ASTNodeSelfGet_New((yyvsp[(1) - (1)].SelfLevel)); SRC((yyval.Node), (yyloc));}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 228 "parser.y"
    {(yyval.Node) = ASTNodeIgnore_New((yyvsp[(2) - (3)].Node), 0); SRC((yyval.Node), (yyloc));}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 229 "parser.y"
    {(yyval.Node) = (yyvsp[(2) - (3)].Node);}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 233 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 234 "parser.y"
    {(yyval.Node) = ASTNodeArrayGet_New((yyvsp[(1) - (4)].Node), (yyvsp[(3) - (4)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 235 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 237 "parser.y"
    {(yyval.Node) = ASTNodeBox_Set_Parent((yyvsp[(3) - (4)].Node), (yyvsp[(1) - (4)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 238 "parser.y"
    {(yyval.Node) = ASTNodeBox_Set_Parent((yyvsp[(3) - (4)].Node), (yyvsp[(1) - (4)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 240 "parser.y"
    {(yyval.Node) = ASTNodeMemberGet_New((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].String), 0);
                                  BoxMem_Free((yyvsp[(3) - (3)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 243 "parser.y"
    {(yyval.Node) = ASTNodeSubtype_Build((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].String));
                                  BoxMem_Free((yyvsp[(3) - (3)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 245 "parser.y"
    {(yyval.Node) = ASTNodeUnOp_New((yyvsp[(2) - (2)].UnaryOperator), (yyvsp[(1) - (2)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 249 "parser.y"
    {(yyval.Node) = NULL;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 250 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 254 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 255 "parser.y"
    {(yyval.Node) = ASTNodeUnOp_New((yyvsp[(1) - (2)].UnaryOperator), (yyvsp[(2) - (2)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 259 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 260 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_POW, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node));
                                  SRC((yyval.Node), (yyloc));}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 265 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 266 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 270 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 271 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 275 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 276 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 280 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 281 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 285 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 286 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 290 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 291 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_BAND, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 295 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 296 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_BXOR, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 300 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 301 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_BOR, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 305 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 306 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_LAND, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 310 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 311 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New(ASTBINOP_LOR, (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 315 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 317 "parser.y"
    {(yyval.Node) = ASTNodeBinOp_New((yyvsp[(2) - (3)].BinaryOperator), (yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 321 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 328 "parser.y"
    {(yyval.TypeMemb).type = (yyvsp[(1) - (1)].Node); (yyval.TypeMemb).name = NULL;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 329 "parser.y"
    {(yyval.TypeMemb).type = (yyvsp[(1) - (2)].Node); (yyval.TypeMemb).name = (yyvsp[(2) - (2)].String);}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 333 "parser.y"
    {(yyval.TypeMemb).type = (yyvsp[(1) - (1)].Node); (yyval.TypeMemb).name = NULL;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 334 "parser.y"
    {(yyval.TypeMemb).type = NULL; (yyval.TypeMemb).name = (yyvsp[(1) - (1)].String);}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 335 "parser.y"
    {(yyval.TypeMemb).type = (yyvsp[(1) - (2)].Node); (yyval.TypeMemb).name = (yyvsp[(2) - (2)].String);}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 339 "parser.y"
    {(yyval.Node) = ASTNodeStrucType_New(& (yyvsp[(1) - (2)].TypeMemb));
                                  BoxMem_Free((yyvsp[(1) - (2)].TypeMemb).name); SRC((yyval.Node), (yyloc));}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 341 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (2)].Node);}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 345 "parser.y"
    {(yyval.Node) = ASTNodeStrucType_New(& (yyvsp[(2) - (2)].TypeMemb));
                                  BoxMem_Free((yyvsp[(2) - (2)].TypeMemb).name); SRC((yyval.Node), (yyloc));}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 347 "parser.y"
    {(yyval.Node) = ASTNodeStrucType_Add_Member((yyvsp[(1) - (2)].Node), & (yyvsp[(2) - (2)].TypeMemb));
                                  BoxMem_Free((yyvsp[(2) - (2)].TypeMemb).name); SRC((yyval.Node), (yyloc));}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 352 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 353 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 358 "parser.y"
    {(yyval.Node) = ASTNodeSpecType_New((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 359 "parser.y"
    {(yyval.Node) = ASTNodeSpecType_Add_Member((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 365 "parser.y"
    {(yyval.Node) = ASTNodeTypeName_New((yyvsp[(1) - (2)].String), 0);
                                  BoxMem_Free((yyvsp[(1) - (2)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 368 "parser.y"
    {(yyval.Node) = ASTNodeSubtype_New((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].String));
                                  BoxMem_Free((yyvsp[(3) - (3)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 373 "parser.y"
    {(yyval.Node) = ASTNodeTypeName_New((yyvsp[(1) - (2)].String), 0);
                                  BoxMem_Free((yyvsp[(1) - (2)].String)); SRC((yyval.Node), (yyloc));}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 375 "parser.y"
    {(yyval.Node) = (yyvsp[(2) - (3)].Node);}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 376 "parser.y"
    {(yyval.Node) = (yyvsp[(2) - (3)].Node);}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 377 "parser.y"
    {(yyval.Node) = (yyvsp[(2) - (3)].Node);}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 381 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 382 "parser.y"
    {}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 386 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 388 "parser.y"
    {}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 392 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 396 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 397 "parser.y"
    {(yyval.Node) = ASTNodeIncType_New((yyvsp[(2) - (2)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 401 "parser.y"
    {(yyval.Node) = ASTNodeTypeDef_New((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 402 "parser.y"
    {(yyval.Node) = ASTNodeTypeDef_New((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 410 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 411 "parser.y"
    {(yyval.Node) = ASTNodeTypeTag_New((yyvsp[(1) - (1)].TTag)); SRC((yyval.Node), (yyloc));}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 416 "parser.y"
    {(yyval.Node) = ASTNodeProcDef_New((yyvsp[(1) - (3)].Node), (yyvsp[(2) - (3)].Combine), (yyvsp[(3) - (3)].Node));
                                  SRC((yyval.Node), (yyloc));}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 421 "parser.y"
    {(yyval.Node) = NULL;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 422 "parser.y"
    {(yyval.Node) = (yyvsp[(1) - (1)].Node);}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 426 "parser.y"
    {(yyval.Node) = ASTNodeProcDef_Set((yyvsp[(1) - (3)].Node), (yyvsp[(2) - (3)].Node), NULL); SRC((yyval.Node), (yyloc));}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 428 "parser.y"
    {(yyval.Node) = ASTNodeProcDef_Set((yyvsp[(1) - (5)].Node), (yyvsp[(2) - (5)].Node), (yyvsp[(4) - (5)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 434 "parser.y"
    {(yyval.Node) = NULL;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 435 "parser.y"
    {(yyval.Node) = ASTNodeStatement_New((yyvsp[(1) - (1)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 436 "parser.y"
    {(yyval.Node) = ASTNodeStatement_New((yyvsp[(1) - (1)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 437 "parser.y"
    {(yyval.Node) = ASTNodeStatement_New(
                                         ASTNodeIgnore_New((yyvsp[(2) - (2)].Node), 1)); SRC((yyval.Node), (yyloc));}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 439 "parser.y"
    {(yyval.Node) = ASTNodeStatement_New((yyvsp[(2) - (3)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 440 "parser.y"
    {(yyval.Node) = ASTNodeStatement_New(ASTNodeError_New());
                                  SRC((yyval.Node), (yyloc));
                                  My_Syntax_Error(& (yyloc), NULL);
                                  assert(yychar == YYEMPTY); yychar = (int) ',';
                                  yyerrok;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 448 "parser.y"
    {(yyval.Node) = ASTNodeBox_New(NULL, (yyvsp[(1) - (1)].Node)); SRC((yyval.Node), (yyloc));}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 449 "parser.y"
    {(yyval.Node) = ASTNodeBox_Add_Sep((yyvsp[(1) - (3)].Node), (yyvsp[(2) - (3)].Sep));
                                  (yyval.Node) = ASTNodeBox_Add_Statement((yyvsp[(1) - (3)].Node), (yyvsp[(3) - (3)].Node)); SRC((yyval.Node), (yylsp[(3) - (3)]));}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 454 "parser.y"
    {program_node = (yyvsp[(1) - (1)].Node);}
    break;



/* Line 1455 of yacc.c  */
#line 2693 "parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 457 "parser.y"


/* error function */
void yyerror(char* s) {
  /* Do nothing, as - at the moment - we report error in error action */
}

static void My_Syntax_Error(YYLTYPE *src, char *s) {
  BoxSrc my_src, *prev_src_of_err;
  my_src.begin.line = src->first_line;
  my_src.begin.col = src->first_column;
  my_src.end.line = src->last_line;
  my_src.end.col = src->last_column;
  prev_src_of_err = Msg_Set_Src(& my_src);
  if (s == NULL)
    MSG_ERROR("Syntax error.");
  else
    MSG_ERROR("%s", s);
  (void) Msg_Set_Src(prev_src_of_err);
}

#if 0
/* Inizializza il parser. Se f != NULL il compilatore partira'
 * come se la prima istruzione del programma fosse una "include nomefile"
 * dove nomefile e' la stringa a cui punta f.
 * maxinc indica il numero massimo di file di include che possono essere
 * aperti contemporaneamente.
 */
Task Parser_Init(const char *f) {

  /* Leggo comunque dallo stdin (che puo' essere stato rediretto)! */
  yyrestart(stdin);

  /* Inizializzo il tokenizer */
  TASK( Tok_Init(NULL, f) );

  //parser_attr.no_syntax_err = 0;

#if YYDEBUG == 1
  yydebug = 1;
#endif

  return Success;
}

/* Completa il parsing del file di input.
 */
Task Parser_Finish(void) {
  Tok_Finish();
  return Success;
}
#endif

ASTNode *Parser_Parse(FILE *in, const char *in_name,
                      const char *auto_include) {
  ASTNode *program;
  int parse_status;
  BoxSrcName *file_names = NULL;

  assert(program_node == NULL);

  if (Tok_Init(in, in_name, auto_include) != BOXTASK_OK)
    return NULL;

  parse_status = yyparse();
  file_names = Tok_Finish();

  if (parse_status) {
    MSG_ERROR("Parse error at end of input.");
    ASTNode_Destroy(program_node);
    BoxSrcName_Destroy(file_names);
    program_node = NULL;
    return NULL;
  }

  program = program_node;
  program_node = NULL;

  assert(program->type == ASTNODETYPE_BOX);
  program->attr.box.file_names = file_names;
  return program;
}



#if 0
Task Parse() {
  struct yy_buffer_state *bufState = NULL;
  yyin = stream_in;
  bufState = yy_create_buffer( /* FILE *fh */ NULL, YY_BUF_SIZE );
  if (! bufState) goto error;
  yy_switch_to_buffer( bufState );

  /* Parse, building the AST */
  if (yyparse() != 0)
      goto error;
  yy_delete_buffer( bufState );
      PRIVATE(yyin) = NULL;
}
#endif


#if 0

/* Every explicit symbol can be followed by a suffix,
 * which specifies which opened box contains the symbol.
 * For example: variable::box1:box2
 * The compiler interprets the string '::box1:box2' as the specification
 * of the box which contains the variable 'v'.
 * The association string --> box-level is obtained by the following
 * function.
 */
Task Prs_Suffix(Int *rs, Int suffix, Name *nm) {
  if ( nm->length > 0 ) {
    Symbol *s;

    /* Cerco il simbolo a profondita' suffix o superiori */
    s = Sym_Explicit_Find(nm, suffix, NO_EXACT_DEPTH);
    if (s == NULL) {
      MSG_ERROR("'%N' <-- type not found!", nm);
      return Failed;
    }

    /* Controllo che sia un tipo, ossia un simbolo con tipo e senza valore. */
    assert( s->value.is.typed );
    if ( s->value.is.value ) {
      MSG_ERROR("'%N' has to be a type!", nm);
      return Failed;
    }

    suffix = (suffix < 0) ? 0 : suffix;
    if ( (*rs = Box_Search_Opened(s->value.type, suffix + 1)) >= 0 )
      return Success;

    MSG_ERROR("'%N' <-- none of the opened box have this type!", nm);
    return Failed;

  } else {
    if ( suffix < 0 ) {
      *rs = 0;
      return Success;
    } else {
      if ( (*rs = suffix + 1) <= Box_Num() ) {
        return Success;
      } else {
        MSG_ERROR("Maximum box depth exceeded.");
        return Failed;
      }
    }
  }
}

/* DESCRIPTION: This function build an array of *num objects of type *x.
 * NOTE: *num is an integer expression. The new type will be put into *array.
 */
Task Prs_Array_Of_X(Expr *array, Expr *num, Expr *x) {
  register Int t, n;

  /* Checks on *num */
  if ( num != NULL ) {
    if ( ! num->is.typed ) {
      MSG_ERROR("L'indice dell'array e' una espressione senza tipo.");
      return Failed;
    }

    if ( ! Tym_Compare_Types(TYPE_INTG, num->type, NULL) ) {
      MSG_ERROR("L'indice dell'array non e' di tipo intero.");
      return Failed;
    }

    if ( (! num->is.value) || (num->categ != CAT_IMM) ) {
      MSG_ERROR(
       "L'indice dell'array deve essere una costante intera positiva.");
      return Failed;
    }

    n = num->value.i;
    if ( n < 1 ) {
      MSG_ERROR("L'indice dell'array e' non positivo!");
      return Failed;
    }

  } else {
    n = -1;
  }

  /* Checks on *x */
  if ( ! x->is.typed ) {
    MSG_ERROR("Cannot create an array of objects with undefined type!");
    return Failed;
  }

  array->is.typed = 1;
  array->is.value = 0;
  array->type = t = Tym_Def_Array_Of(n, x->type);
  if ( t != TYPE_NONE ) return Success;
  return Failed;
}

#endif

